﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Microsoft.Xna.Framework;
using Monocle;
using Celeste;

namespace Celeste.Mod.RubysEntities
{
    class HeightDisplayTrigger : Trigger
    {
        private Level level;

        private Vector2 start;
        private string startLevel;

        private bool enabled;
        private int altitude;
        private int approach_from;
        private float approach_speed;

        private string text;

        public HeightDisplayTrigger(EntityData data, Vector2 offset) : base(data, offset)
        {
            altitude = data.Int("altitude", 0);
            approach_from = data.Int("approach_from", altitude - 500);
            approach_speed = data.Float("approach_speed", 10f);
            text = data.Attr("text");

            enabled = true;
        }

        public override void OnEnter(Player player)
        {
            //display the height thingie and disable this trigger afterwards
            if (enabled)
            {
                level.Add(new AltHeightDisplay(altitude, approach_from, approach_speed, text));
            }
            enabled = false;
        }

        public override void Added(Scene scene)
        {
            base.Added(scene);

            level = scene as Level;
            if (level == null)
                return;

            start = Position;
            startLevel = level.Session.Level;
        }
    }
}
